#! /bin/sh
# @(#)selecmidas.sh	1.1 (ESO-IPG) 07/12/91 14:16:04
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           selecmidas.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: 
#
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION 2.2    881114:	Cosmetic changes
# .VERSION 2.3    891205:	CG Adding "echo" definition.
# .VERSION 3.1    901128:	CG New directory structure.
# .VERSION 3.2	  910213        CG SPEC to be included before LONG or ECHELLE

spec=n
cmd=`basename $0`
echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# START
#
if [ -z "$MIDASHOME" -o -z "$MIDVERS" ] ; then
   echo "Error: Variable \$MIDASHOME or \$MIDVERS not defined."
   exit 1
fi
MID_INSTALL=$MIDASHOME/$MIDVERS/install/unix

#
# Check for first argument. If none select `all' pacakages.
#
if [ -n "$1" ] ; then
   option=$1
else
   option=all
fi

case $option in 
all|own|core)
   continue
   ;;
*)
   echo "$option bad argument"
   echo "Usage: $cmd [all|core|own]   (default=all)"
   exit 1
   ;;
esac

trap "echo 'INTERRUPT: <midas.cnf> NOT modified.' ; stty echo; exit" 2

cp core.cnf temporary.cnf
chmod u+rw temporary.cnf

if [ "$option" != "core" ] ; then
 clear
 stty -echo
 echo ""
 echo ""
 echo "	LIST OF AVAILABLE PACKAGES IN MIDAS:"
 echo ""
 echo "	NAME		CATEGORY [YN]? (Y)"
 echo "	========================================="
 for categ in applic stdred contrib
 do
    if [ ! -d $MIDASHOME/$MIDVERS/$categ ]; then
	continue
    fi
    cd $MIDASHOME/$MIDVERS/$categ
    for pack in `ls -r | egrep -v 'lib|exec|proc|help'`
    do
	if [ -f $pack/src/makefile -o \
	     -f $pack/libsrc/makefile -o \
	     -f $pack/proc/makefile ] ; then
	    $echo  "	$pack     	$categ		"  $SV_NONL
	    if [ "$option" = "all" ] ; then
		answ=y
	    else
	        read answ
	    fi
	    if [ -z "$answ" ]; then
		answ=y
	    fi
	    if [ "$answ" = "y" -o "$answ" = "Y" ] ; then
		echo y
		# 
		# "spec" have to be included before "long" and "echelle"
		#
		if [ "$categ" = "stdred" -a "$pack" = "spec" ] ; then
		    spec=y
		fi
		if [ "$categ" = "stdred" \
		  -a \( "$pack" = "long" -o "$pack" = "echelle" \) \
		  -a "$spec" = "n" ] ; then
		    echo \$MIDASHOME/\$MIDVERS/$categ/spec/libsrc >> $MID_INSTALL/temporary.cnf
		    echo \$MIDASHOME/\$MIDVERS/$categ/spec/src >> $MID_INSTALL/temporary.cnf
		    echo \$MIDASHOME/\$MIDVERS/$categ/spec/proc >> $MID_INSTALL/temporary.cnf
	            echo  "	spec		$categ		y (also included)"
		    spec=y
		fi
	        if [ -f $pack/libsrc/makefile ] ; then
		    echo \$MIDASHOME/\$MIDVERS/$categ/$pack/libsrc >> $MID_INSTALL/temporary.cnf
		    # $echo "lib" $SV_NONL
	        fi
	        if [ -f $pack/src/makefile ] ; then
		    echo \$MIDASHOME/\$MIDVERS/$categ/$pack/src >> $MID_INSTALL/temporary.cnf
		    # $echo " src" $SV_NONL
	        fi
	        if [ -f $pack/proc/makefile ] ; then
		    echo \$MIDASHOME/\$MIDVERS/$categ/$pack/proc >> $MID_INSTALL/temporary.cnf
		    # $echo " proc" $SV_NONL
	        fi
	    else
		echo n
	    fi
	fi
    done
 done
 cd $MID_INSTALL
 stty echo
 echo ""
 $echo "Do you want this MIDAS configuration [yn]? (y): " $SV_NONL
else
 echo ""
 $echo "Do you want only MIDAS core configuration [yn]? (y): " $SV_NONL
fi

read answ
if [ -z "$answ" ]; then
    answ=y
fi
if [ "$answ" != "y" -a "$answ" != "Y" ]
then
    echo "NOTE: Your configuration file <midas.cnf> has NOT been modified."
    exit 0
fi

mv temporary.cnf midas.cnf
echo "NOTE: Your configuration file <midas.cnf> has been modified."
exit 0
done
