#! /bin/sh
# @(#)setinmidas.sh	1.1 (ESO-IPG) 07/12/91 14:16:04
# .COPYRIGHT: Copyright (c) 1988 European Southern Observatory,
#                                         all rights reserved
# .TYPE           command
# .NAME           setinmidas.sh
# .LANGUAGE       shell script
# .ENVIRONMENT    Unix Systems. Executable under SHELL and C-SHELL
# .COMMENTS       
#                 Usage: setinmidas
# .REMARKS        The external variable $MIDASHOME and $MIDVERS must be set 
#
# .AUTHOR         Carlos Guirao
# .VERSION 3.2	  910213        Implementation

# Remove posible previous definitions:
#unset MIDASHOME0 MIDASHOME1 MIDASHOME2 MIDASHOME3
#unset MIDVERS0 MIDVERS1 MIDVERS2 MIDVERS3

#
# Check how echo command removes new-line.
#
cmd=`basename $0`
echo=echo
if [ "`echo -n`" = "-n" ] ; then
    SV_NONL="\c"
else
    echo="echo -n"
fi

#
# First of all, goto the command directory and
# <dirname> & <basename> commands emulated with <sed>
#
#cd `dirname $0`
cd `echo $0 | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`
VERSDIR=`pwd | sed 's/\/install\/unix$//'`
#MIDVERS=`basename $VERSDIR`
MIDVERS=`echo $VERSDIR | sed -e 's/^.*\///'`
#MIDASHOME=`dirname $VERSDIR`
MIDASHOME=`echo $VERSDIR | sed -e 's/[^\/]*$//' -e 's/^$/./' -e 's/\/$//'`

#
# Check access to directories and files
#
if [ ! -d $MIDASHOME ]; then
        echo "${MIDASHOME}: no such directory."
	exit 1
fi
if [ ! -d $MIDASHOME/$MIDVERS ]; then
        echo "$MIDASHOME/${MIDVERS}: no such directory."
	exit 1
fi
#
# Set default MIDASHOME0 and MIDVERS0 to current values
#
MIDASHOME0=$MIDASHOME
MIDVERS0=$MIDVERS

#
# Check existance of files to be configured
#
FILE0=$MIDASHOME/$MIDVERS/system/unix/inmidas.sh
FILE1=$MIDASHOME/$MIDVERS/system/unix/setmidas.sh
FILE2=$MIDASHOME/$MIDVERS/system/unix/inmidas.csh
FILE3=$MIDASHOME/$MIDVERS/system/unix/setmidas.csh
if [ ! -f $FILE0 ]; then
        echo "${FILE0}: no such file."
	exit 1
fi
if [ ! -f $FILE1 ]; then
        echo "${FILE1}: no such file."
	exit 1
fi
if [ ! -f $FILE2 ]; then
        echo "${FILE2}: no such file."
	exit 1
fi
if [ ! -f $FILE3 ]; then
        echo "${FILE3}: no such file."
	exit 1
fi

while :
do
echo ""
echo "Current list of MIDAS releases:"
echo ""
if [ -n "$MIDASHOME0" -a -n "$MIDVERS0" ]; then
    MIDASHOME_0=`echo MIDASHOME0=$MIDASHOME0 | sed 's/\//\\\\\//g'`
    MIDVERS_0=`echo MIDVERS0=$MIDVERS0 | sed 's/\//\\\\\//g'`
    MIDASHOME_0_set="set $MIDASHOME_0"
    MIDVERS_0_set="set $MIDVERS_0"
    echo "	0- MIDASHOME: $MIDASHOME0"
    echo "	   MIDVERS  : $MIDVERS0"
else
    MIDASHOME_0="#MIDASHOME0="
    MIDVERS_0="#MIDVERS0="
    MIDASHOME_0_set="#set MIDASHOME0="
    MIDVERS_0_set="#set MIDVERS0="
    echo "	0- Empty"
fi
if [ -n "$MIDASHOME1" -a -n "$MIDVERS1" ]; then
    MIDASHOME_1=`echo MIDASHOME1=$MIDASHOME1 | sed 's/\//\\\\\//g'`
    MIDVERS_1=`echo MIDVERS1=$MIDVERS1 | sed 's/\//\\\\\//g'`
    MIDASHOME_1_set="set $MIDASHOME_1"
    MIDVERS_1_set="set $MIDVERS_1"
    echo "	1- MIDASHOME: ${MIDASHOME1}"
    echo "	   MIDVERS  : ${MIDVERS1}"
else
    MIDASHOME_1="#MIDASHOME1="
    MIDVERS_1="#MIDVERS1="
    MIDASHOME_1_set="#set MIDASHOME1="
    MIDVERS_1_set="#set MIDVERS1="
    echo "	1- Empty"
fi
if [ -n "$MIDASHOME2" -a -n "$MIDVERS2" ]; then
    MIDASHOME_2=`echo MIDASHOME2=$MIDASHOME2 | sed 's/\//\\\\\//g'`
    MIDVERS_2=`echo MIDVERS2=$MIDVERS2 | sed 's/\//\\\\\//g'`
    MIDASHOME_2_set="set $MIDASHOME_2"
    MIDVERS_2_set="set $MIDVERS_2"
    echo "	2- MIDASHOME: ${MIDASHOME2}"
    echo "	   MIDVERS  : ${MIDVERS2}"
else
    MIDASHOME_2="#MIDASHOME2="
    MIDVERS_2="#MIDVERS2="
    MIDASHOME_2_set="#set MIDASHOME2="
    MIDVERS_2_set="#set MIDVERS2="
    echo "	2- Empty"
fi
if [ -n "$MIDASHOME3" -a -n "$MIDVERS3" ]; then
    MIDASHOME_3=`echo MIDASHOME3=$MIDASHOME3 | sed 's/\//\\\\\//g'`
    MIDVERS_3=`echo MIDVERS3=$MIDVERS3 | sed 's/\//\\\\\//g'`
    MIDASHOME_3_set="set $MIDASHOME_3"
    MIDVERS_3_set="set $MIDVERS_3"
    echo "	3- MIDASHOME: ${MIDASHOME3}"
    echo "	   MIDVERS  : ${MIDVERS3}"
else
    MIDASHOME_3="#MIDASHOME3="
    MIDVERS_3="#MIDVERS3="
    MIDASHOME_3_set="#set MIDASHOME3="
    MIDVERS_3_set="#set MIDVERS3="
    echo "	3- Empty"
fi
echo ""
$echo "Enter option (CR to finish): " $SV_NONL
read option

case $option in
0)
    if [ -n "$MIDASHOME0" -a -n "$MIDVERS0" ]; then
	echo "	0- MIDASHOME:	$MIDASHOME0"
	echo "	   MIDVERS  :	$MIDVERS0"
    fi
    $echo "	0- MIDASHOME: " $SV_NONL
    read MIDASHOME0
    $echo "	   MIDVERS  : "  $SV_NONL
    read MIDVERS0
    ;;
1)
    if [ -n "$MIDASHOME1" -a -n "$MIDVERS1" ]; then
	echo "	1- MIDASHOME:	$MIDASHOME1"
	echo "	   MIDVERS  :	$MIDVERS1"
    fi
    $echo "	1- MIDASHOME: " $SV_NONL
    read MIDASHOME1
    $echo "	   MIDVERS  : "  $SV_NONL
    read MIDVERS1
    ;;
2)
    if [ -n "$MIDASHOME2" -a -n "$MIDVERS2" ]; then
	echo "	2- MIDASHOME:	$MIDASHOME2"
	echo "	   MIDVERS  :	$MIDVERS2"
    fi
    $echo "	2- MIDASHOME: " $SV_NONL
    read MIDASHOME2
    $echo "	   MIDVERS  : "  $SV_NONL
    read MIDVERS2
    ;;
3)
    if [ -n "$MIDASHOME3" -a -n "$MIDVERS3" ]; then
	echo "	3- MIDASHOME:	$MIDASHOME3"
	echo "	   MIDVERS  :	$MIDVERS3"
    fi
    $echo "	3- MIDASHOME: " $SV_NONL
    read MIDASHOME3
    $echo "	   MIDVERS  : "  $SV_NONL
    read MIDVERS3
    ;;
'')
    $echo "Do you accept this list [yn]? (y): " $SV_NONL
    read answ
    if [ -z "$answ" ]; then
	answ=y
    fi
    if [ "$answ" = "y" -o "$answ" = "Y" ]; then
	break
    fi
    ;;
*) 
    echo "${option}: Unknown option"
    ;;
esac
done

echo ""
echo "OK. I'm now editing your files: "
echo ""
echo "	$FILE0"
echo " 	$FILE1"
echo "	$FILE2"
echo "	$FILE3"
echo ""

#
# IFS: To cancel space as argument separator
#
IFS=''

#
# NOTE: This could be done easier with ed, but in UNIX SYSTEM V 
# ed exits when a pattern is not found.
#
for file in $FILE0 $FILE1 $FILE2 $FILE3
do
echo "Editing $file ..." 
cat $file | sed  \
	-e 's/^MIDVERS0=.*/'$MIDVERS_0'/' \
	-e 's/^#MIDVERS0=.*/'$MIDVERS_0'/' \
	-e 's/^set MIDVERS0=.*/'$MIDVERS_0_set'/' \
	-e 's/^#set MIDVERS0=.*/'$MIDVERS_0_set'/' \
	-e 's/^MIDASHOME0=.*/'$MIDASHOME_0'/' \
	-e 's/^#MIDASHOME0=.*/'$MIDASHOME_0'/' \
	-e 's/^set MIDASHOME0=.*/'$MIDASHOME_0_set'/' \
	-e 's/^#set MIDASHOME0=.*/'$MIDASHOME_0_set'/' \
	-e 's/^MIDVERS1=.*/'$MIDVERS_1'/' \
	-e 's/^#MIDVERS1=.*/'$MIDVERS_1'/' \
	-e 's/^set MIDVERS1=.*/'$MIDVERS_1_set'/' \
	-e 's/^#set MIDVERS1=.*/'$MIDVERS_1_set'/' \
	-e 's/^MIDASHOME1=.*/'$MIDASHOME_1'/' \
	-e 's/^#MIDASHOME1=.*/'$MIDASHOME_1'/' \
	-e 's/^set MIDASHOME1=.*/'$MIDASHOME_1_set'/' \
	-e 's/^#set MIDASHOME1=.*/'$MIDASHOME_1_set'/' \
	-e 's/^MIDVERS2=.*/'$MIDVERS_2'/' \
	-e 's/^#MIDVERS2=.*/'$MIDVERS_2'/' \
	-e 's/^set MIDVERS2=.*/'$MIDVERS_2_set'/' \
	-e 's/^#set MIDVERS2=.*/'$MIDVERS_2_set'/' \
	-e 's/^MIDASHOME2=.*/'$MIDASHOME_2'/' \
	-e 's/^#MIDASHOME2=.*/'$MIDASHOME_2'/' \
	-e 's/^set MIDASHOME2=.*/'$MIDASHOME_2_set'/' \
	-e 's/^#set MIDASHOME2=.*/'$MIDASHOME_2_set'/' \
	-e 's/^MIDVERS3=.*/'$MIDVERS_3'/' \
	-e 's/^#MIDVERS3=.*/'$MIDVERS_3'/' \
	-e 's/^set MIDVERS3=.*/'$MIDVERS_3_set'/' \
	-e 's/^#set MIDVERS3=.*/'$MIDVERS_3_set'/' \
	-e 's/^MIDASHOME3=.*/'$MIDASHOME_3'/' \
	-e 's/^#MIDASHOME3=.*/'$MIDASHOME_3'/' \
	-e 's/^set MIDASHOME3=.*/'$MIDASHOME_3_set'/' \
	-e 's/^#set MIDASHOME3=.*/'$MIDASHOME_3_set'/' \
> $file.ed
mv $file.ed $file
done
echo "Done."
echo ""
echo "**********************************************************************"
echo "If you use a C-Shell, write the following lines in your <.cshrc> file:"
echo "  setenv setmidas \"source $MIDASHOME/$MIDVERS/system/unix/setmidas.csh\""
echo "  setenv inmidas \"source $MIDASHOME/$MIDVERS/system/unix/inmidas.csh\""
echo ""
echo "If you use a Bourne-Shell, write the following lines in your <.profile> file:"
echo "  setmidas=\". $MIDASHOME/$MIDVERS/system/unix/setmidas.csh\""
echo "  inmidas=\". $MIDASHOME/$MIDVERS/system/unix/inmidas.csh\""
echo ""
echo "To run MIDAS, type:"
echo "  \$setmidas	(if you want to change MIDAS defaults)"
echo "  \$inmidas	(if you want to run MIDAS defaults)"
echo "**********************************************************************"
echo "Type any character to finish." 
read answ
exit
